#!/usr/bin/python

# Copyright(C) 2008 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# senna webserver
# TODO: libevent with ctypes

import sys
import sennadb
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer

class SennaHandler(BaseHTTPRequestHandler):
  def do_GET(self):
    # check self.path
    self.send_response(200)
    self.send_header('Content-type', 'text/html')
    self.end_headers()
    self.wfile.write('senna web server GET')

  def do_POST(self):
    self.send_response(200)
    self.send_header('Content-type', 'text/html')
    self.end_headers()
    self.wfile.write('senna web server POST')

def main():
  if len(sys.argv) != 2:
    print 'usage: ./webserver.py portnumber'
    exit(1)

  try:
    server = HTTPServer(('', int(sys.argv[1])), SennaHandler)
    print 'start Senna web server...'
    server.serve_forever()
  except KeyboardInterrupt:
    print 'shut down...'
    server.socket.close()

if __name__ == '__main__':
  main()
