#!/usr/bin/python
from distutils.core import setup
from distutils.extension import Extension

try:
  from Cython.Distutils import build_ext
  no_cython= False
except ImportError:
  no_cython = True

if no_cython:
    cmdclass = {}
    src = ['src/sennadb.c']
else:
    cmdclass = { 'build_ext': build_ext }
    src = ['src/sennadb.pyx']

setup(
  name = 'sennadb',
  version = '0.1',
  description = 'Senna DB API Python bindings',
  long_description = '''
  Senna DBAPI python bindings.
  ''',
  license='GNU LESSER GENERAL PUBLIC LICENSE',
  author = 'Brazil',
  author_email = 'senna at razil.jp',
  ext_modules = [Extension('sennadb',
                         src,
                         libraries = ['senna']),],
  cmdclass = cmdclass)
