(define (show-schema)
  (letrec ((f (lambda (x)
                (if x
                  (let ((s (x ::schema)))
                    (cond ((pair? s) (display (x ::schema)) (newline)))
                    (f (<db> ::+ x)))))))
    (f (<db> ::))))

(define-macro time
  (lambda (x)
    (write (cdr x)) (newline)
    `(let* ([t0 (now)]
            [res (begin ,@(cdr x))])
       (write (- (now) t0)) (display "s\n")
       res)))

(define (gensym) (intern (x->b32h (* (x->number (now)) 1000000))))

(define (map proc list)
    (if (pair? list)
        (cons (proc (car list)) (map proc (cdr list)))))

(define (for-each proc list)
    (if (pair? list)
        (begin (proc (car list)) (for-each proc (cdr list)))
        #t ))

(define (list-tail x k)
    (if (zero? k)
        x
        (list-tail (cdr x) (- k 1))))

(define (list-ref x k)
    (car (list-tail x k)))

(define (last-pair x)
    (if (pair? (cdr x))
        (last-pair (cdr x))
        x))

;; (do ((var init inc) ...) (endtest result ...) body ...)
(define-macro do
  (lambda (do-macro)
    (apply (lambda (do vars endtest . body)
             (let ((do-loop (gensym)))
               `(letrec ((,do-loop
                          (lambda ,(map (lambda (x)
                                          (if (pair? x) (car x) x))
                                        `,vars)
                            (if ,(car endtest)
                                (begin ,@(cdr endtest))
                                (begin
                                  ,@body
                                  (,do-loop
                                   ,@(map (lambda (x)
                                            (cond
                                             ((not (pair? x)) x)
                                             ((< (length x) 3) (car x))
                                             (else (car (cdr (cdr x))))))
                                          `,vars)))))))
                  (,do-loop
                   ,@(map (lambda (x)
                            (if (and (pair? x) (pair? (cdr x))) (car (cdr x))))
                          `,vars)))))
           do-macro)))

